import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
--Turbine.Shell.WriteLine( "Start" );
--Creating the controls
	DetailWindow = class( Turbine.UI.Window );
	
	LabelLoot = Turbine.UI.Label();
	LabelQuest = Turbine.UI.Label();
	LabelVendor = Turbine.UI.Label();
	LabelMail = Turbine.UI.Label();

	NextDay = false;
	
	ArrayData = {};
	LootDetails = {};
	
function DetailWindow:Constructor()
	
	Turbine.UI.Lotro.Window.Constructor( self );
	
	--We want to let the Escape button trigger the disappearing of the screens
		self:SetWantsKeyEvents( true );
	
	--Creating the window
		self.minWidth = 420;
		self.minHeight = 500;
		self:SetPosition(300,130);	
		self:SetSize( 360, 150 );
		self:SetBackColor( Turbine.UI.Color(0.0,0,0,0) );
		self:SetOpacity( 8 );
		self:SetText( "Details" );
		self.disableResize = true;

	--Adding controls
		LabelLoot:SetText( "Loot: " );
		LabelLoot:SetSize(300, 15 );
		LabelLoot:SetPosition(30, 35 );
		LabelLoot:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelLoot:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelLoot:SetParent( self );
		LabelLoot:SetVisible( true );

		LabelQuest:SetText( "Quests:" );
		LabelQuest:SetSize(300, 15 );
		LabelQuest:SetPosition(30, 55 );
		LabelQuest:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelQuest:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelQuest:SetParent( self );
		LabelQuest:SetVisible( true );
		
		LabelVendor:SetText( "Vendor" );
		LabelVendor:SetSize(300, 15 );
		LabelVendor:SetPosition(30, 75 );
		LabelVendor:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelVendor:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelVendor:SetParent( self );
		LabelVendor:SetVisible( true );
		
		LabelMail:SetText( "Mail: " );
		LabelMail:SetSize(300, 15 );
		LabelMail:SetPosition(30, 95 );
		LabelMail:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelMail:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelMail:SetParent( self );
		LabelMail:SetVisible( true );
end

function DetailWindow:Update(Loot, Quest, Vendor, Mail)
	if Vendor ~= nil and Loot ~= nil and Quest ~= nil and Mail ~= nil then
		LabelLoot:SetText(   "Loot:   " .. Loot );
		LabelQuest:SetText(  "Quest:  " .. Quest );
		LabelVendor:SetText( "Vendor: " .. Vendor );
		LabelMail:SetText(   "Mail:   " .. Mail );
	else
		Turbine.Shell.WriteLine( "No data found" );
	end
end

function round(num) 
	return math.floor(num+.5)
end