import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
--Turbine.Shell.WriteLine( "Start" );
--Creating the controls
	MainWindow = class( Turbine.UI.Window );
	Date = Turbine.Engine.GetDate();
	LabelEarned2 = Turbine.UI.Label();
	
	Year = "";
	Month = "";
	Day = "";
	PrevDay = "";
	TotalString = "";
	TotalDate = "";
	VendorString = TotalDate .. "Gold: " .. 0 .. " Silver: " .. 0 .. " Copper: " .. 0;
	MailString = TotalDate .. "Gold: " .. 0 .. " Silver: " .. 0 .. " Copper: " .. 0;
	QuestString = TotalDate .. "Gold: " .. 0 .. " Silver: " .. 0 .. " Copper: " .. 0;
	LootMobString = TotalDate .. "Gold: " .. 0 .. " Silver: " .. 0 .. " Copper: " .. 0;
	
	GoldCollected = 0;
	SilverCollected = 0;
	CopperCollected = 0;
	RenownCollected = 0;
	Page = 1;
	LootGold = 0;
	QuestGold = 0;
	VendorGold = 0;
	MailGold = 0;
	LootSilver = 0;
	QuestSilver = 0;
	VendorSilver = 0;
	MailSilver = 0;
	LootCopper = 0;
	QuestCopper = 0;
	VendorCopper = 0;
	MailCopper = 0;
	
	NextDay = false;
	
	ArrayData = {};
	LootDetails = {};
	
function MainWindow:Constructor()
	
	Turbine.UI.Lotro.Window.Constructor( self );
	
	--We want to let the Escape button trigger the disappearing of the screens
		self:SetWantsKeyEvents( true );
	
	--Creating the window
		self.minWidth = 420;
		self.minHeight = 500;
		self:SetPosition(300,300);	
		self:SetSize( 420, 500 );
		self:SetBackColor( Turbine.UI.Color(0.0,0,0,0) );
		self:SetOpacity( 8 );
		self:SetText( "Goldtracker" );
		self.disableResize = true;

	--Get the current day
		MainWindow:GetDate()

	--Adding controls
		LabelDate = Turbine.UI.Label();
		LabelDate:SetText( "Current day: ".. Day .. "/" .. Month .. "/" .. Year );
		LabelDate:SetSize(270, 15 );
		LabelDate:SetPosition(30, 35 );
		LabelDate:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelDate:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelDate:SetParent( self );
		LabelDate:SetVisible( true );

		LabelEarned = Turbine.UI.Label();
		LabelEarned:SetText( "Earned:" );
		LabelEarned:SetSize(50, 15 );
		LabelEarned:SetPosition(200, 35 );
		LabelEarned:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelEarned:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelEarned:SetParent( self );
		LabelEarned:SetVisible( true );
		
		LabelEarned2:SetText( "G:0 S:0 C:0" );
		LabelEarned2:SetSize(130, 15 );
		LabelEarned2:SetPosition(260, 35 );
		LabelEarned2:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelEarned2:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelEarned2:SetParent( self );
		LabelEarned2:SetVisible( true );
		
		LabelListDate = Turbine.UI.Label();
		LabelListDate:SetText( "Day: " );
		LabelListDate:SetSize(50, 15 );
		LabelListDate:SetPosition(30, 55 );
		LabelListDate:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelListDate:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelListDate:SetParent( self );
		LabelListDate:SetVisible( true );
		
		LabelListGold = Turbine.UI.Label();
		LabelListGold:SetText( "Earned: " );
		LabelListGold:SetSize(50, 15 );
		LabelListGold:SetPosition(109, 55 );
		LabelListGold:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelListGold:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelListGold:SetParent( self );
		LabelListGold:SetVisible( true );

	--Placing an invisible label to handle click events
		self.ClickLabel = Turbine.UI.Label();
		self.ClickLabel:SetSize(350,350);
		self.ClickLabel:SetPosition(30,70);
		self.ClickLabel:SetParent( self );
		self.ClickLabel:SetZOrder( 99 );
		
	--Making the listbox
		self.ListboxGoldEarned = Turbine.UI.ListBox();
		self.ListboxGoldEarned:SetParent( self );
		self.ListboxGoldEarned:SetSize( 350, 350 );
		self.ListboxGoldEarned:SetPosition( 30, 70 );
		self.ListboxGoldEarned:SetBackColor(Turbine.UI.Color(0.91,0,0,0));
		self.ListboxGoldEarned:SetVisible(true);
	
	--Creating Buttons
		--Next Page
			ButtonNP = Turbine.UI.Lotro.Button();
			ButtonNP:SetParent( self );
			ButtonNP:SetText( "Next" );
			ButtonNP:SetPosition( 260, 430 );
			ButtonNP:SetSize( 105, 20 );
			ButtonNP:SetVisible(true);
			
		--Previous page
			ButtonPP = Turbine.UI.Lotro.Button();
			ButtonPP:SetParent( self );
			ButtonPP:SetText( "Previous" );
			ButtonPP:SetPosition( 40, 430 );
			ButtonPP:SetSize( 105, 20 );
			ButtonPP:SetVisible(true);
			
		--Clear data
			ButtonCD = Turbine.UI.Lotro.Button();
			ButtonCD:SetParent( self );
			ButtonCD:SetText( "Clear" );
			ButtonCD:SetPosition( 150, 430 );
			ButtonCD:SetSize( 105, 20 );
			ButtonCD:SetVisible(true);
	
	--Load Detail data
		self.ClickLabel.MouseClick = function( sender, args )
			local DataFound = false;
			ListNr = 0;
			for ClickedPos = 0, 22, 1 do
				ListNr = ListNr + 1;
				if ( args.Y < ClickedPos * 15 ) then
					if ( args.Y > (ClickedPos - 1) * 15 ) then
						if ClickedPos > table.getn(ArrayData) then
							break;
						end
						for x = 1, table.getn(LootDetails), 1 do
							Date = string.sub(LootDetails[x], 1 , (string.find(LootDetails[x], "_ ") - 1));
							Date2 = string.sub(ArrayData[ClickedPos], 1 , (string.find(ArrayData[ClickedPos], "  ") - 1));
							if Date == Date2 then
								detailWindow:SetVisible( true );
								Loot = string.sub(LootDetails[x], (string.find(LootDetails[x], "_", 1) + 2), string.len(LootDetails[x]));
								Quest = string.sub(LootDetails[x + 1], (string.find(LootDetails[x + 1], "_", 1) + 2), string.len(LootDetails[x + 1]));
								Vendor = string.sub(LootDetails[x + 2], (string.find(LootDetails[x + 2], "_", 1) + 2), string.len(LootDetails[x + 2]));
								Mail = string.sub(LootDetails[x + 3], (string.find(LootDetails[x + 3], "_", 1) + 2), string.len(LootDetails[x + 3])); 
								DetailWindow:Update(Loot, Quest, Vendor, Mail);
								DataFound = true;
								break;
							end
						end
						if DataFound == false then
							Turbine.Shell.WriteLine( "Data not found" );
						end
						break;
						
					end
				end
			end
		end
		
	--Clear button is pressed
		ButtonCD.Click = function( sender, args )
			self.ListboxGoldEarned:ClearItems();
			GoldCollected = 0;
			SilverCollected = 0;
			CopperCollected = 0;
			ArrayData = {};
			table.insert(ArrayData, "");
			MainWindow:SaveData(ArrayData, Day);
			for i = 1, 22, 1 do
				local label = Turbine.UI.Label();
				label:SetText("");
				label:SetSize(350, 15 );
				label:SetBackColor( Turbine.UI.Color(0.91,0,0,0) );
				label:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
				self.ListboxGoldEarned:AddItem(label);
			end
		end

	--Next Page button is pressed
		ButtonNP.Click = function( sender, args )
			self.ListboxGoldEarned:ClearItems();
			TotalPages = table.getn(ArrayData) / 22;
			TotalPages = round(TotalPages+.5);
			if ( Page < TotalPages ) then
				Page = Page + 1;
			end
			for i = 1, table.getn(ArrayData), 1 do
				local label = Turbine.UI.Label();
				if ( i + (22 * (Page - 1)) <= table.getn(ArrayData) ) then
					MountNumber = i + (22 * (Page - 1));
					label:SetText( ArrayData[MountNumber] );
					label:SetSize(350, 15 );
					label:SetBackColor( Turbine.UI.Color(0.91,0,0,0) );
					label:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
					self.ListboxGoldEarned:AddItem(label);
					if (i == (22 * Page)) then
						break
					end
				end
			end
		end
	
	--Previous page button is pressed
		ButtonPP.Click = function( sender, args )
			if ( Page > 1 ) then
				self.ListboxGoldEarned:ClearItems();
				Page = Page - 1;
				TotalPages = table.getn(ArrayData) / 22;
				TotalPages = round(TotalPages+.5);
				for j = 1, table.getn(ArrayData), 1 do
					local label = Turbine.UI.Label();
					if ( j + (22 * (Page - 1)) <= table.getn(ArrayData) ) then
						MountNumber = j + (22 * (Page - 1));
						label:SetText( ArrayData[MountNumber] );
						label:SetSize(350, 15 );
						label:SetBackColor( Turbine.UI.Color(0.91,0,0,0) );
						label:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
						self.ListboxGoldEarned:AddItem(label);
						if (j == (22 * Page)) then
							break
						end
					end
				end
			end
		end
		
	--Clear the old list
		self.ListboxGoldEarned:ClearItems();
		
	--Load previous data
		if ( Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroStat_GoldEarned") ~= nil ) then
			ArrayData = MainWindow:LoadData()
		end
		if ( Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroStat_LootDetails") ~= nil ) then
			LootDetails = MainWindow:LoadDetailData();
			
			for x = 1, table.getn(LootDetails), 1 do
				Date = string.sub(LootDetails[x], 1 , (string.find(LootDetails[x], "_ ") - 1));
				if Date == TotalDate then
					local LootCounter = 0;
					local QuestCounter = 0;
					local VendorCounter = 0;
					local MailCounter = 0;
					LootMobString = string.sub(LootDetails[x], (string.find(LootDetails[x], "_", 1) + 2), string.len(LootDetails[x]));
					QuestString = string.sub(LootDetails[x+1], (string.find(LootDetails[x+1], "_", 1) + 2), string.len(LootDetails[x+1]));
					VendorString = string.sub(LootDetails[x+2], (string.find(LootDetails[x+2], "_", 1) + 2), string.len(LootDetails[x+2]));
					MailString = string.sub(LootDetails[x+3], (string.find(LootDetails[x+3], "_", 1) + 2), string.len(LootDetails[x+3]));
					
					for y in string.gmatch(LootMobString, "%d+") do
						if ( LootCounter == 0 ) then
							LootGold = y;
						end
						if ( LootCounter == 1 ) then
							LootSilver = y;
						end
						if ( LootCounter == 2 ) then
							LootCopper = y;
						end
						LootCounter = LootCounter + 1
					end
					for y in string.gmatch(QuestString, "%d+") do
						if ( QuestCounter == 0 ) then
							QuestGold = y;
						end
						if ( QuestCounter == 1 ) then
							QuestSilver = y;
						end
						if ( QuestCounter == 2 ) then
							QuestCopper = y;
						end
						QuestCounter = QuestCounter + 1
					end
					for y in string.gmatch(VendorString, "%d+") do
						if ( VendorCounter == 0 ) then
							VendorGold = y;
						end
						if ( VendorCounter == 1 ) then
							VendorSilver = y;
						end
						if ( VendorCounter == 2 ) then
							VendorCopper = y;
						end
						VendorCounter = VendorCounter + 1
					end
					for y in string.gmatch(MailString, "%d+") do
						if ( MailCounter == 0 ) then
							MailGold = y;
						end
						if ( MailCounter == 1 ) then
							MailSilver = y;
						end
						if ( MailCounter == 2 ) then
							MailCopper = y;
						end
						MailCounter =MailCounter + 1
					end
					break;
				end
			end
		end
			
		MainWindow:LoadDay()
	if PrevDay ~= Day then
		PrevDay = Day;
		NextDay = true;
	else
		
	end
	
	--Update the listbox
	if Turbine.Chat.Received and ArrayData ~= nil then
		self.ListboxGoldEarned:ClearItems();
		for i = 1, table.getn(ArrayData), 1 do
			j = i + ((Page - 1) * 22);
			if j > (((Page - 1) * 22) + 22) then
				break
			end
			local label = Turbine.UI.Label();
			label:SetText(ArrayData[j]);
			label:SetSize(350, 15 );
			label:SetBackColor( Turbine.UI.Color(0.91,0,0,0) );
			label:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
			self.ListboxGoldEarned:AddItem(label);
		end
	end
end
	
function MainWindow:GetDate()
	Year = Date.Year;
	Month = Date.Month;
	Day = Date.Day;
	TotalDate = Day .. "/" .. Month .. "/" .. Year;
end

Turbine.Chat.Received = function(sender,args)
	local ChatType = Turbine.ChatType;
	ChatType = args.ChatType;
	--Turbine.Shell.WriteLine( "Chattype: " .. ChatType .. " Message: " .. args.Message );
	if ChatType == 36 and string.find(args.Message,"You looted") or ChatType == 21 and string.find(args.Message,"You've earned") or ChatType == 4 and string.find(args.Message,"You sold") or ChatType == 4 and string.find(args.Message,"You received") then
			local LootgoldString = ""
			if string.match(args.Message, "%d+ gold") ~= nil then
				LootgoldString = string.match(args.Message, "%d+ gold");
			else
				LootgoldString = "0";
			end
			
			local LootSilverString = ""
			if string.match(args.Message, "%d+ silver") ~= nil then
				LootSilverString = string.match(args.Message, "%d+ silver");
			else
				LootSilverString = "0";
			end
			
			local LootCopperString = ""
			if string.match(args.Message, "%d+ copper") ~= nil then
				LootCopperString = string.match(args.Message, "%d+ copper");
			else
				LootCopperString = "0";
			end
			
		if string.find(args.Message,"You looted") then --Mob and Chests
			LootGold = LootGold + string.match(LootgoldString, "%d+");
			LootSilver = LootSilver + string.match(LootSilverString, "%d+");
			LootCopper = LootCopper + string.match(LootCopperString, "%d+");
			if ( LootCopper > 100 ) then
				LootCopper = LootCopper % 100;
				LootSilver = LootSilver + 1
			end
			if ( LootSilver > 1000 ) then
				LootSilver = LootSilver % 1000;
				LootGold = LootGold + 1
			end
			if ( TotalDate == nil ) then
				MainWindow:GetDate();
			end
			LootMobString = TotalDate .. "_ Gold: " .. LootGold .. " Silver: " .. LootSilver .. " Copper: " .. LootCopper;
		elseif string.find(args.Message,"You've earned") then --Quest
			QuestGold = QuestGold + string.match(LootgoldString, "%d+");
			QuestSilver = QuestSilver + string.match(LootSilverString, "%d+");
			QuestCopper = QuestCopper + string.match(LootCopperString, "%d+");
			if ( QuestCopper > 100 ) then
				QuestCopper = QuestCopper % 100;
				QuestSilver = QuestSilver + 1
			end
			if ( QuestSilver > 1000 ) then
				QuestSilver = QuestSilver % 1000;
				QuestGold = QuestGold + 1
			end
			if ( TotalDate == nil ) then
				MainWindow:GetDate();
			end
			QuestString = TotalDate .. "_ Gold: " .. QuestGold .. " Silver: " .. QuestSilver .. " Copper: " .. QuestCopper;
		elseif string.find(args.Message,"You sold") then --Vendor
			VendorGold = VendorGold + string.match(LootgoldString, "%d+");
			VendorSilver = VendorSilver + string.match(LootSilverString, "%d+");
			VendorCopper = VendorCopper + string.match(LootCopperString, "%d+");
			if ( VendorCopper > 100 ) then
				VendorCopper = VendorCopper % 100;
				VendorSilver = VendorSilver + 1
			end
			if ( VendorSilver > 1000 ) then
				VendorSilver = VendorSilver % 1000;
				VendorGold = VendorGold + 1
			end
			if ( TotalDate == nil ) then
				MainWindow:GetDate();
			end
			VendorString = TotalDate .. "_ Gold: " .. VendorGold .. " Silver: " .. VendorSilver .. " Copper: " .. VendorCopper;
		elseif string.find(args.Message,"You received") then --Mail
			MailGold = MailGold + string.match(LootgoldString, "%d+");
			MailSilver = MailSilver + string.match(LootSilverString, "%d+");
			MailCopper = MailCopper + string.match(LootCopperString, "%d+");
			if ( MailCopper > 100 ) then
				MailCopper = MailCopper % 100;
				MailSilver = MailSilver + 1
			end
			if ( MailSilver > 1000 ) then
				MailSilver = MailSilver % 1000;
				MailGold = MailGold + 1
			end
			if ( TotalDate == nil ) then
				MainWindow:GetDate();
			end
			MailString = TotalDate .. "_ Gold: " .. MailGold .. " Silver: " .. MailSilver .. " Copper: " .. MailCopper;
		end
		
	if string.find(args.Message,"gold") then
			local Gold = 0;
			local StringGold = "";
			StringGold = string.match(args.Message, "%d+ gold");
			Gold = string.match(StringGold, "%d+");
			GoldCollected = GoldCollected + Gold;
		end
		if string.find(args.Message,"silver") then
			local Silver = 0;
			local StringSilver = "";
			StringSilver = string.match(args.Message, "%d+ silver");
			Silver = string.match(StringSilver, "%d+");
			SilverCollected = SilverCollected + Silver;
		end
		if string.find(args.Message,"copper") then
			local Copper = 0;
			local StringCopper = "";
			StringCopper = string.match(args.Message, "%d+ copper");
			Copper = string.match(StringCopper, "%d+");
			CopperCollected = CopperCollected + Copper;
		end
		
		if CopperCollected >= 100 then
			CopperCollected = CopperCollected - 100;
			SilverCollected = SilverCollected + 1;
		end
		if SilverCollected >= 1000 then
			SilverCollected = SilverCollected - 1000;
			GoldCollected = GoldCollected + 1;
		end
		--Turbine.Shell.WriteLine( "Gold: " .. GoldCollected .. " Silver: " .. SilverCollected .. " Copper: " .. CopperCollected );
		TotalString = TotalDate .. "  Gold: " .. GoldCollected .. " Silver: " .. SilverCollected .. " Copper: " .. CopperCollected;
		if (string.find(LootMobString, "_ ")) == nil then
			LootMobString = TotalDate .. "_ " .. LootMobString;
		end
		if (string.find(QuestString, "_ ")) == nil then
			QuestString = TotalDate .. "_ " .. QuestString;
		end
		if (string.find(VendorString, "_ ")) == nil then
			VendorString = TotalDate .. "_ " .. VendorString;
		end
		if (string.find(MailString, "_ ")) == nil then
			MailString = TotalDate .. "_ " .. MailString;
		end
		if NextDay == true then
			table.insert(LootDetails, LootMobString);
			table.insert(LootDetails, QuestString);
			table.insert(LootDetails, VendorString);
			table.insert(LootDetails, MailString);
			table.insert(ArrayData, TotalString);
			NextDay = false;
		else
			local ArrayCnt = 0;
			ArrayCnt = table.getn(ArrayData);
			local ArrayCnt2 = 0;
			ArrayCnt2 = table.getn(LootDetails);
			if ArrayCnt >= 1 then
				table.remove(ArrayData, ArrayCnt);
				table.remove(LootDetails, ArrayCnt2); -- ((ArrayCnt2 - 1) * 4) + 1);
				table.remove(LootDetails, ArrayCnt2 - 1); --((ArrayCnt2 - 1) * 4) + 2);
				table.remove(LootDetails, ArrayCnt2 - 2); --((ArrayCnt2 - 1) * 4) + 3);
				table.remove(LootDetails, ArrayCnt2 - 3); --((ArrayCnt2 - 1) * 4) + 4);
			end
			table.insert(ArrayData, ArrayCnt, TotalString);
			table.insert(LootDetails, ArrayCnt2 - 3, LootMobString); --((ArrayCnt2 - 1) * 4) + 1, LootMobString);
			table.insert(LootDetails, ArrayCnt2 - 2, QuestString); --((ArrayCnt2 - 1) * 4) + 2, QuestString);
			table.insert(LootDetails, ArrayCnt2 - 1, VendorString); --((ArrayCnt2 - 1) * 4) + 3, VendorString);
			table.insert(LootDetails, ArrayCnt2, MailString); --((ArrayCnt2 - 1) * 4) + 4, MailString);
		end
		LabelEarned2:SetText( "G:" .. GoldCollected .. " S:" .. SilverCollected .. " C:" .. CopperCollected );
		MainWindow:SaveData(ArrayData, Day, LootDetails);
	end
end

function MainWindow:SaveData(Array, Lastday, Details)
	Turbine.PluginData.Save(Turbine.DataScope.Character, "LotroStat_GoldEarned", Array);
	Turbine.PluginData.Save(Turbine.DataScope.Character, "LotroStat_LootDetails", Details);
	local ArrayLastDay = {};
	table.insert(ArrayLastDay, Lastday);	
		table.insert(ArrayLastDay, CopperCollected);
		table.insert(ArrayLastDay, SilverCollected);
		table.insert(ArrayLastDay, GoldCollected);

	Turbine.PluginData.Save(Turbine.DataScope.Character, "LotroStat_LastDay", ArrayLastDay);
end

function MainWindow:LoadData()
	Array = Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroStat_GoldEarned")
	if Array == nil then
		Array = {};
	end

	return Array
end

function MainWindow:LoadDetailData()
	local Array = {};
	Array = Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroStat_LootDetails")
	if Array == nil then
		Array = {};
	end

	return Array
end

function MainWindow:LoadDay()
	local ArrayLoad = {};
	if Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroStat_LastDay") ~= nil then
		ArrayLoad = Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroStat_LastDay")
		if ArrayLoad[1] == Day then
			PrevDay = ArrayLoad[1];
			CopperCollected = ArrayLoad[2];
			SilverCollected = ArrayLoad[3];
			GoldCollected = ArrayLoad[4];
		else
			PrevDay = ArrayLoad[1];
			CopperCollected = 0;
			SilverCollected = 0;
			GoldCollected = 0;
		end
	LabelEarned2:SetText( "G:" .. GoldCollected .. " S:" .. SilverCollected .. " C:" .. CopperCollected );
	end
end

function round(num) 
	return math.floor(num+.5)
end